namespace :wta_routes do
  desc "Parse Bus Routes"
  task :parse => :environment do
    
    require 'nokogiri'
    require 'open-uri'
    require 'sanitize'
    require 'activesupport'
    require 'actionpack'
    require 'action_view/helpers'

    extend ActionView::Helpers    
        
    routes = Route.find(:all)
    
    puts "Starting parse..."
    
    routes.each do |route|
      puts "Fetching route #{route.url}..."
      doc = Nokogiri::HTML(open("http://ridewta.com/route_#{route.url}"))

      puts "Parsing route #{route.url}..."
      
      parsed_schedule = ''
      
      doc.css('.content table').each do |input_table|
        parsed_schedule += Sanitize.clean(input_table.inner_html, 
          :elements => ['table', 'tbody', 'thead', 'tr', 'th', 'td', 'strong', 'span', 'em'], 
          :attributes => {'td' => ['colspan', 'rowspan', 'class', 'id']})
        
        parsed_schedule = parsed_schedule.gsub(/<td>\s*<\/td>/, '')
        parsed_schedule = parsed_schedule.gsub(/LEAVE/, '')
        parsed_schedule = parsed_schedule.gsub(/ARRIVE/, '')
      end
      
      route.schedule = parsed_schedule 
      route.save
    end
  end
end